#version 150 core

uniform int mode;
uniform sampler2D texture;

in vec2 UV;

out vec4 outColor;

void noPostProcess(){
	outColor = texture2D(texture, UV);
}

//Not working!
void blurShading(){
	float rt_w = 1024;
	float rt_h = 768;
	float offset[3] = float[]( 0.0, 1.3846153846, 3.2307692308 );
	float weight[3] = float[]( 0.2270270270, 0.3162162162, 0.0702702703 );
	
	vec3 tc = vec3(1.0, 0.0, 0.0);

	vec2 uv = UV.xy;
	tc = texture2D(texture, UV).rgb * weight[0];
	for (int i=1; i<3; i++){
		vec2 sstp = vec2( offset[i]/rt_w , 0.0f);
		tc += texture2D(texture, UV + sstp).rgb / weight[i];
		tc += texture2D(texture, UV - sstp).rgb / weight[i];
	}
	outColor = vec4(tc, 1.0);
}

void cellShading(){
	float imageWidthFactor = 1024.0f; 
	float imageHeightFactor = 768.0f; 
	
	float intensity = 0.2f;

	//vec3 W = vec3(0.2125, 0.7154, 0.0721);
	vec3 W = vec3(0.7125, 0.9154, 0.5721);
	
	vec3 textureColor = texture2D(texture, UV).rgb;

	vec2 stp0 = vec2(1.0 / imageWidthFactor, 0.0);
    vec2 st0p = vec2(0.0, 1.0 / imageHeightFactor);
    vec2 stpp = vec2(1.0 / imageWidthFactor, 1.0 / imageHeightFactor);
    vec2 stpm = vec2(1.0 / imageWidthFactor, -1.0 / imageHeightFactor);

    float i00   = dot( textureColor, W);
    
	float im1m1 = dot( texture2D(texture, UV - stpp).rgb, W);
    float ip1p1 = dot( texture2D(texture, UV + stpp).rgb, W);
    
	float im1p1 = dot( texture2D(texture, UV - stpm).rgb, W);
    float ip1m1 = dot( texture2D(texture, UV + stpm).rgb, W);
    
	float im10 = dot( texture2D(texture, UV - stp0).rgb, W);
    float ip10 = dot( texture2D(texture, UV + stp0).rgb, W);
    
	float i0m1 = dot( texture2D(texture, UV - st0p).rgb, W);
    float i0p1 = dot( texture2D(texture, UV + st0p).rgb, W);
    
	float h = -im1p1 - 2.0 * i0p1 - ip1p1 + im1m1 + 2.0 * i0m1 + ip1m1;
    float v = -im1m1 - 2.0 * im10 - im1p1 + ip1m1 + 2.0 * ip10 + ip1p1;

    float mag = 1.0 - length(vec2(h, v));
    vec3 target = vec3(mag);
	
	if(target.r < 0.5f ) outColor = vec4(mix(textureColor, target, 0.5), 1.0);
	else outColor = vec4(mix(textureColor, target, 0.1), 1.0);
	
	//outColor = vec4(mix(textureColor, target, intensity), 1.0);
	//outColor = vec4(textureColor,1.0f);
	//outColor = vec4(target,1.0f);
}

void main(void)
{	
	if(mode == 0) cellShading();
	else if(mode ==1) noPostProcess();
}
